<template>
  <div>
    <Header />
    <div class="container">
      <Balance />
      <IncomeExpenses />
      <TransactionList @transaction-deleted="handleTransactionDeleted" />
      <AddTransaction @transaction-submitted="handleTransactionSubmitted" />
    </div>
  </div>
</template>

<script setup>
import { onMounted, computed } from 'vue'
import Header from './components/Header.vue'
import Balance from './components/Balance.vue'
import IncomeExpenses from './components/IncomeExpenses.vue'
import TransactionList from './components/TransactionList.vue'
import AddTransaction from './components/AddTransaction.vue'
import { useToast } from 'vue-toastification'
import { useTransactionStore } from './store/transaction'
const toast = useToast()
const transactionStore = useTransactionStore()
const transactions = computed(() => transactionStore.transactions)

onMounted(() => {
  loadTransactionsFromLocalStorage()
})

const handleTransactionSubmitted = (transactionData) => {
  console.log(transactionData, 'transaction')
  transactionStore.addTransaction({
    text: transactionData.text,
    amount: transactionData.amount
  })
  saveTransactionsToLocalStorage()
  toast.success('Transaction added')
}

const handleTransactionDeleted = (id) => {
  transactionStore.deleteTransaction(id)
  saveTransactionsToLocalStorage()
  toast.success('Transaction deleted')
}

const saveTransactionsToLocalStorage = () => {
  localStorage.setItem('transactions', JSON.stringify(transactionStore.transactions))
}

const loadTransactionsFromLocalStorage = () => {
  const savedTransactions = JSON.parse(localStorage.getItem('transactions'))
  console.log(savedTransactions, 'saved transactions')
  if (savedTransactions) {
    transactions.value = savedTransactions
  } else {
    // transactions.value = []
    localStorage.setItem('transactions', JSON.stringify(transactions.value))
  }
}
</script>
